      subroutine bldxu(deg,xupt,yupt,wxupt,nxupt)
      implicit none
c
c     build acos(Xu points) on [-1,1]^2 
c     left-right, bottom-up
c
      integer deg,nxupt
c
c     deg   (i) degree 
c     nxupt (o) number of Xu points
c
      double precision pi
      parameter (pi= 3.1415926535897931D0)
      double precision xupt(*),yupt(*),wxupt(*)
c     xupt  (o) first coord. of Xu points
c     yupt  (o) second coord. of Xu points
c
      integer i,j,deg2,m
      nxupt=0
      deg2 = deg ** 2
      if (mod(deg,2) .eq. 0) then
         m = deg / 2
c primo gruppo
         do j=1,deg-1,2
            nxupt = nxupt+1
            xupt(nxupt) = cos(j * pi / deg)
            wxupt(nxupt) = 1.0d0 / deg2
         end do
         do i=2,m
            do j=1,deg-1,2
               nxupt = nxupt+1
               xupt(nxupt) = cos(j * pi / deg)
               wxupt(nxupt) = 2.0d0 / deg2
            end do
         end do   
         do j=1,deg-1,2
            nxupt = nxupt+1
            xupt(nxupt) = cos(j * pi / deg)
            wxupt(nxupt) = 1.0d0 / deg2
         end do
c secondo gruppo
         do i=1,m
            nxupt = nxupt+1
            xupt(nxupt) = cos(0 * pi / deg)
            wxupt(nxupt) = 1.0d0 / deg2
         end do
         do j=2,deg-2,2
            do i=1,m
               nxupt = nxupt+1
               xupt(nxupt) = cos(j * pi / deg)
               wxupt(nxupt) = 2.0d0 / deg2
            end do
         end do   
         do i=1,m
            nxupt = nxupt+1
            xupt(nxupt) = cos(deg * pi / deg)
            wxupt(nxupt) = 1.0d0 / deg2
         end do
         do i=1,nxupt
            yupt(i) = xupt(mod(m*(m+1)+i-1,nxupt)+1)
         end do   
      else
         m = (deg - 1) / 2
c primo gruppo
         do j = 0,deg-1,2
            nxupt = nxupt + 1
            xupt(nxupt) = cos(j*pi/deg)
            wxupt(nxupt) = 1.0d0 / deg2
         end do   
         wxupt(1) = wxupt(1) / 2
         do i = 2,m+1
            nxupt = nxupt + 1
            xupt(nxupt) = cos(0*pi/deg)
            wxupt(nxupt) = 1.0d0 / deg2
            do j = 2,deg-1,2
               nxupt = nxupt + 1
               xupt(nxupt) = cos(j*pi/deg)
               wxupt(nxupt) = 2.0d0 / deg2
            end do   
         end do   
c     secondo gruppo
         do i = 1,m+1
            nxupt = nxupt + 1
            xupt(nxupt) = cos(deg*pi/deg)
            wxupt(nxupt) = 1.0d0 / deg2
         end do   
         wxupt(nxupt-m) = wxupt(nxupt -m) / 2
         do j = deg-2,1,-2
            nxupt = nxupt + 1
            xupt(nxupt) = cos(j*pi/deg)
            wxupt(nxupt) = 1.0d0 / deg2
            do i = 2,m+1
               nxupt = nxupt + 1
               xupt(nxupt) = cos(j*pi/deg)
               wxupt(nxupt) = 2.0d0 / deg2
            end do   
         end do   
         do i=1,nxupt
            yupt(i) = -xupt(mod((m+1)**2+i-1,nxupt)+1)
         end do   
      end if
      return
      end
